FUNCTION SaveRestoreTableEnv(pcModus, paArray, pcAlias)
* klid/obnoven prosted tabulky: filter, tag, asc/desc, ID vty, relace
*	ukldan tabulka mus mt kl ID a tag ID
* struktura dku pole pro uloen:
* sloupec 1. filter()
* 				2. tag()
* 				3. "DESCENDING", "ASCENDING"
* 				4. RecNo() / Bof(), Eof()
* 				5. relace v jednom stringu vraz1+chr(10)+vraz2...
*					6. alias

external array paArray
local xcV1, xcV2, xcSel, xnI, lnUsed, lnPocetRadku, lcRelace, lnIndex, lnID, lcReturn
local array laAliases(1), laRelations(1)
lcReturn=""
pcAlias=Upper(Alltrim(IIF(empty(pcAlias), Alias(), pcAlias)))
xcSel=Alias()

IF Upper(left(pcModus, 1))=="S"		&& save

	lnUsed=AUsed(laAliases)		&& seznam otevench tabulek
	IF lnUsed=0
		RETURN .F.
	ENDIF
	lnPocetRadku=1
	FOR lnIndex=1 to lnUsed
		IF like( pcAlias, Upper(laAliases(lnIndex, 1)) )		&& m se uklidit
			dimension paArray(lnPocetRadku, 6)
			select (laAliases(lnIndex, 1))
			paArray[lnPocetRadku, 6]=alias()
			paArray[lnPocetRadku, 1]=filter()
			paArray[lnPocetRadku, 2]=tag()
			paArray[lnPocetRadku, 3]=IIF(descending(), "DESCENDING", "ASCENDING")
			DO CASE
				CASE RecCount()=0
					paArray[lnPocetRadku, 4]=-3
				CASE Bof()
					paArray[lnPocetRadku, 4]=-1
				CASE Eof()
					paArray[lnPocetRadku, 4]=-2
				OTHERWISE
					lnID=evaluate(Alias()+".ID")
					IF VarType(lnID) != "N"
						lcReturn="SaveRestoreTableEnv: nelze uloit pozici vty"+chr(10)+Alias()+".ID neexistuje"
*						MessageBox("SaveRestoreTableEnv: nelze uloit pozici vty"+chr(10)		;
*										+Alias()+".ID neexistuje", 16, cProgram)
						paArray[lnPocetRadku, 4]=-9
					ELSE
						paArray[lnPocetRadku, 4]=lnID
					ENDIF
			ENDCASE
			lcRelace=""
			xnI=1
			Do while .T.	&&  zjitn potu relaci
				xcV1=relation(xnI)
				if empty(xcV1)		&& dal relace u nen
					exit
				endif
				lcRelace=lcRelace+xcV1+" into "+Target(xnI)+chr(10)		&& uloen relace		
				xnI=xnI+1
			EndDo
			paArray[lnPocetRadku, 5]=lcRelace
			
			lnPocetRadku=lnPocetRadku+1
		ENDIF
	ENDFOR


ELSE			&& restore

	lnPocetRadku=ALen(paArray, 1)
	FOR xnI=1 to lnPocetRadku
		select ( paArray[xni, 6] )		&& alias
		set filter to
		set relation to
		DO CASE
			CASE paArray[xni, 4] = -9		&& pozice (ID) neuloena

			CASE paArray[xni, 4] = -1		&& BOF
				go top
			CASE paArray[xni, 4] = -2		&& EOF
				go bottom
			CASE paArray[xni, 4] = -3		&& RecCount=0
			OTHERWISE
				lnID=paArray[xni, 4]
				IF .not.seek(lnID, Alias(), "ID")
					lcReturn="SaveRestoreTableEnv: nelze obnovit pozici vty"+chr(10)+Alias()+".ID: "+Transform(lnID)+" neexistuje"
*					MessageBox("SaveRestoreTableEnv: nelze obnovit pozici vty"+chr(10)		;
*								+Alias()+".ID: "+Transform(lnID)+" neexistuje", 16, cProgram)		
				ENDIF
		ENDCASE
		xcV1=paArray[xni, 2]					&& tag
		IF .not.empty(xcV1)
			xcV2=paArray[xni, 3]				&&  asc/desc
			set order to tag &xcV1. &xcV2.
		ENDIF
		xcV1=paArray[xni, 1]		&& filter
		set filter to &xcV1.
		lcRelace=paArray[xni, 5]		&& relation
		IF .not.empty(lcRelace)
			lnUsed=ALines(laRelations, lcRelace, .T.)	&& rozebrn relac do pole
			for each lcRelace in laRelations
				set relation to &lcRelace. additive
			endfor
		ENDIF

	ENDFOR

ENDIF
select (iif(empty(xcSel), 0, (xcSel)) )
RETURN lcReturn